--- old/grub/grub-core/commands/search_wrap.c	2012-08-31 05:08:51.868877048 +0400
+++ new/grub/grub-core/commands/search_wrap.c	2012-08-31 05:08:51.884072587 +0400
@@ -63,6 +63,7 @@
      N_("First try the device HINT if currently running on ARC."
 	" If HINT ends in comma, also try subpartitions"),
      N_("HINT"), ARG_TYPE_STRING},
+    {"zfs-mirror", 'z', 0, N_("Handle zfs-mirror disk"), 0, 0},
     {0, 0, 0, 0, 0, 0}
   };
 
@@ -79,6 +80,7 @@
     SEARCH_HINT_BAREMETAL,
     SEARCH_HINT_EFI,
     SEARCH_HINT_ARC,
+    SEARCH_ZFS_MIRROR,
  };
 
 static grub_err_t
@@ -89,6 +91,7 @@
   const char *id = 0;
   int i = 0, j = 0, nhints = 0;
   char **hints = NULL;
+  int mirror_mode = 0;
 
   if (state[SEARCH_HINT].set)
     for (i = 0; state[SEARCH_HINT].args[i]; i++)
@@ -177,15 +180,18 @@
   else
     return grub_error (GRUB_ERR_BAD_ARGUMENT, N_("one argument expected"));
 
+  if (state[SEARCH_ZFS_MIRROR].set)
+    mirror_mode = 1;
+
   if (state[SEARCH_LABEL].set)
     grub_search_label (id, var, state[SEARCH_NO_FLOPPY].set, 
-		       hints, nhints);
+		       hints, nhints, mirror_mode);
   else if (state[SEARCH_FS_UUID].set)
     grub_search_fs_uuid (id, var, state[SEARCH_NO_FLOPPY].set,
-			 hints, nhints);
+			 hints, nhints, mirror_mode);
   else if (state[SEARCH_FILE].set)
     grub_search_fs_file (id, var, state[SEARCH_NO_FLOPPY].set, 
-			 hints, nhints);
+			 hints, nhints, mirror_mode);
   else
     return grub_error (GRUB_ERR_INVALID_COMMAND, "unspecified search type");
 
